/********************************************************
*	
*
*				by devoto
*
*   
********************************************************/

// Gba.h has all the register definitions
#include "gba.h"     //from Eloist Wire cube Demo, defines the main GBA registers

#include "keypad.h"  //All the keypad definitions thanks to nokturn


///REG_DISPCNT Defines////
#define BG0_ENABLE		0x100    //these are just the flags for enabling backgrounds and sprites
#define BG1_ENABLE		0x200
#define BG2_ENABLE		0x400
#define BG3_ENABLE		0x800
#define OBJ_ENABLE		0x1000
#define WIN0_ENABLE		0x2000
#define WIN1_ENABLE		0x4000
#define WINOBJ_ENABLE	0x8000


#define OBJ_MAP_LINEAR  0x40     //I'll talk about this when i talk about hardware sprites
#define OBJ_MAP_2D      0x0
#define BACK_BUFFER     0x10     //this is the flag that controlls wich buffer is being rendered
	

#define MODE0			0x0     //these are the modes
#define MODE1			0x1
#define MODE2			0x2
#define MODE3			0x3
#define MODE4			0x4
#define MODE5			0x5


/////////////SetMode////////////////////
void SetMode(u16 mode)
{
	REG_DISPCNT = mode;   //REG_DISPCNT (defined in gba.h) is the main display register that controls
					//the mode of operation which backgrounds are enabled and wich buffer is
					//currently being drawn by the GPU.
}
//////////////////////////////////////

#define RGB16(r,g,b)  ((r)+(g<<5)+(b<<10))  //this converts a color value to 15 bit BGR value used by GBA
								//you can have 0-31 levels of each red,green,blue component.			
#define SCREENWIDTH 240  //width of the screen in pixels
#define SCREENHEIGHT 160 //height
///////////////// C code entry (main())/////////////////////
int AgbMain()
{
   char x,y;  //counters to loop through all x and y positions on the screen

   u16* ScreenBuffer = (u16*)0x6000000; //this is the start of video memory

	SetMode(MODE3 | BG2_ENABLE);  //this sets the screen mode to mode three and enables background 2
						//background 2 is required for all bitmap modes(3-5)

	
	
	for(x = 0; x<240;x++)   //loop through all x
	{
		for(y = 0; y<160; y++)  //loop through all y
		{
			ScreenBuffer[x+y*SCREENWIDTH] = RGB16(31,0,0);  //uses a macro to convert the red,green,blue to a 
											//16 bit value.  And paints the screen red
		}
	}
	while(1){}	//loop forever

}//end C_entry()
//////////////////////////////////////////////

///////////////Get Input////////////////////////////////
int Get_Input(void)
{
	int d = -1; //just a variable to return direction..
//keypad register is a 16 bit register at 0x40000130;
//key bits are cleared when a key is pressed.  
//keys are defined in keypad.h
//this function is not used in this tutorial

	if(!((*KEYS) & KEY_UP))        //is UP bit 0?
	{
	}
	if(!((*KEYS) & KEY_DOWN))
	{
		//do down stuff
	}
	if(!((*KEYS) & KEY_LEFT))
	{
	
		//do left stuff
	}
	if(!((*KEYS) & KEY_RIGHT))
	{
	
		//do right stuff
	}
	if(!((*KEYS) & KEY_A))
	{
		//do A button stuff here
	}
	if(!((*KEYS) & KEY_B))
	{
		//do B button stuff here
	}
	if(!((*KEYS) & KEY_R))
	{
		//do R button stuff here
	}
	if(!((*KEYS) & KEY_L))
	{
		//do R button stuff here
	}


	return d;
}




	
	
