/********************************************************
*	
*
*				by devoto
*
*   
********************************************************/
#include"gba.h"
#include"screenmode.h"
#include"keypad.h"
#include"sprite.h"


#include"sprite1.h"
#include"sprite2.h"
#include"test.h" //from day 2

///declare our functions so the c compiler knows what we are talking about

void InitializeSprites(void);
void WaitForVsync(void);
void CopyOAM(void);
void GetInput(void);
void MoveSprite(OAMEntry* sp, int x, int y);

///these are global so i do not have to pass them to GetInput
s16 x = 10;
s16 y = 10;
u16 char_number = 0;


//my plot pixle function from day 2
void PlotPixel(int x,int y, unsigned short int c) {VideoBuffer[(y) *120 + (x)] = (c);}


///main entry point from the boot.asm startup file
int AgbMain(void)
{
	int x_loop,y_loop,index = 0;  //some looping variables for loops :)
	u16 loop;
	
	
	
	SetMode(MODE_4 | BG2_ENABLE| OBJ_ENABLE | OBJ_MAP_1D); //set mode 2 and enable sprites and 2d mapping 

	for(loop = 0; loop < 256; loop++)
		OBJPaletteMem[loop] = sprite1Palette[loop];	//loop through and store the palette from your pict 
									//palette into obj palette mem OBJPaletteMem is 
									//defined in gba.h.  sprite1Palette is from
									//pcx2gba tool sprite1.h.
	for(loop = 0; loop < 256; loop++)
		BGPaletteMem[loop] = testPalette[loop];	//loop through and store the palette from your pict 
									//palette into video palette mem 
	
	for(y = 0; y < 160; y++)
	{
		for(x = 0; x < 120; x++)

		{
			PlotPixel(x,y,testData[y*120+x]);//testData contains the color values of your pict
			
		}
	}

	x = 10;
	y = 10;
	InitializeSprites();  //set all 128 sprites to offscreen

	//this is were we define our sprite atributes for the first sprite
	//256 color 64x64 sprite that starts at character 0.  Character 0 is
	//the first sprite data memory location.

	sprites[0].attribute0 = COLOR_256 | SQUARE | MODE_TRANSPERANT | y;  
	sprites[0].attribute1 = SIZE_64 | x;
	sprites[0].attribute2 = char_number+512; //bit map mode so the first 512 chars are not available

	sprites[1].attribute0 = COLOR_256 | SQUARE | y;  
	sprites[1].attribute1 = SIZE_64 | x;
	sprites[1].attribute2 = char_number+512+(128); //bit map mode so the first 512 chars are not available each 64x64 sprite uses 128 tiles
								
	
//allright now to copy in the sprites bitmap.  The data in sprite1Data is allready striped 
//so we just copy it in one row of tiles at a time.  The only difference between this and a 
//2D sprite is that we would need to keep in mind the fact that the tiles are not all in a row.
//We could just use one big for loop.  There are 8 rows (64x64 = 8x8 tiles) so we loop through
//all 8.  There is 512 bytes per row (8 tiles * 8x8 = 512) but since we copy 2 bytes at a 
//time that equals 256.  The width of char memory is 32 * 8x8 = 1024 (512 double bytes).
//	
		for(index = 0; index < 256*8; index++)
		{
			OAMData[index+(512*16)] = sprite1Data[index];  //copy it starting 512 tiles into oamdata mem.  remember one tile = 32bytes and OAMdata is 16 bit pointer so offset is 512*16
			
		}//end index loop
		for(index =0 ; index <256*8 ; index++)
		{
			OAMData[index+256*8+(512*16)] = sprite2Data[index];  
			
		}//end index loop


//okay now we do the transperancy

REG_BLDMOD = (1<<4) | (1<<10);
REG_COLEV = (8) + (8<<8);


///Main Game loop	
	while(1)
	{
		GetInput();    //get input changes the x and y based on input
		MoveSprite(&sprites[0],x,y); //changes sprite atributes based on new x,y
		MoveSprite(&sprites[1],x>>1,y>>1);
		WaitForVsync();			//waits for the screen to stop drawing
		CopyOAM();				//Copies our sprite array into OAM.
	}
	
}

////Set sprites to off screen

void InitializeSprites(void)
{
	int loop;
	for(loop = 0; loop < 128; loop++)
	{
		sprites[loop].attribute0 = 160;  //y to > 159
		sprites[loop].attribute1 = 240;  //x to > 239
	}
}

//wait for the screen to stop drawing
void WaitForVsync(void)
{
	while((volatile u16)REG_VCOUNT != 160){}	

}

///Copy our sprite array to OAM
void CopyOAM(void)
{
	u16 loop;
	u16* temp;
	temp = (u16*)sprites;
	for(loop = 0; loop < 128*4; loop++)
	{
		OAM[loop] = temp[loop];
	}
}

///Test for key presses
void GetInput(void)
{
	if(!(*KEYS & KEY_UP))
	{
 		y--;
	}
	if(!(*KEYS & KEY_DOWN))
	{
 		y++;
	}
	if(!(*KEYS & KEY_LEFT))
	{
 		x--;
	}
	if(!(*KEYS & KEY_RIGHT))
	{
 		x++;
	}
}

//move the sprite
void MoveSprite(OAMEntry* sp, int x, int y)
{
	if(x < 0)			//if it is off the left corect
		x = 512 + x;
	if(y < 0)			//if off the top corect
		y = 256 + y;

	sp->attribute1 = sp->attribute1 & 0xFE00;  //clear the old x value
	sp->attribute1 = sp->attribute1 | x;
	
	sp->attribute0 = sp->attribute0 & 0xFF00;  //clear the old y value
	sp->attribute0 = sp->attribute0 | y;
}	
